{-----------------------------------------------------------------------------
                          ---> Project DelphiWorks <---
                                   Version 1.3
 -----------------------------------------------------------------------------
 Unit:        dwConsts.pas
 Description: Constants for DelphiWorks
 Author:      Codehunter Works
 Release:     1.3
 State:       Stable
 Date:        16.08.2004
 Created:     14.12.2002
 Last mod.:   11.12.2003
 History:     n/a
-----------------------------------------------------------------------------}


unit dwConsts;

interface

uses Graphics, Windows;

type
	HTMLstr = string[8];


const
{-----------------------------------------------------------------------------
 Description: Constants for dwApplication
-----------------------------------------------------------------------------}
   FLASHW_STOP = 					0;
   FLASHW_CAPTION = 				1;
   FLASHW_TRAY = 					2;
   FLASHW_ALL = 					FLASHW_CAPTION or FLASHW_TRAY;
   FLASHW_TIMER = 				4;
   FLASHW_TIMERNOFG = 			12;

{-----------------------------------------------------------------------------
 Description: Constants for dwConvert
-----------------------------------------------------------------------------}
   DW_NOTATION_BIN: String = '01';
   DW_NOTATION_DEC: String = '0123456789';
   DW_NOTATION_HEX: String = '0123456789ABCDEF';
   DW_NOTATION_OCT: String = '01234567';

{-----------------------------------------------------------------------------
 Description: Constants for dwDialogs
-----------------------------------------------------------------------------}
   FOCUSDLG_DOMAINS_ONLY = 				1;
   FOCUSDLG_SERVERS_ONLY = 				2;
   FOCUSDLG_SERVERS_DOMAINS = 			3;
   FOCUSDLG_BROWSE_LOGON_DOMAIN = 		$00010000;
   FOCUSDLG_BROWSE_WKSTA_DOMAIN = 		$00020000;
   FOCUSDLG_BROWSE_OTHER_DOMAINS = 		$00040000;
   FOCUSDLG_BROWSE_TRUSTING_DOMAINS = 	$00080000;
   FOCUSDLG_BROWSE_WORKGROUP_DOMAINS = $00100000;
   FOCUSDLG_BROWSE_ALL_DOMAINS = 		FOCUSDLG_BROWSE_LOGON_DOMAIN or
     												FOCUSDLG_BROWSE_WKSTA_DOMAIN or
                                       FOCUSDLG_BROWSE_OTHER_DOMAINS or
                                       FOCUSDLG_BROWSE_TRUSTING_DOMAINS or
                                       FOCUSDLG_BROWSE_WORKGROUP_DOMAINS;
   RFF_NOOPT =									0;
   RFF_NOBROWSE = 							1;
   RFF_NODEFAULT = 							2;
   RFF_CALCDIRECTORY = 						4;
   RFF_NOLABEL = 								8;
   RFF_NOSEPARATEMEM = 						14;

   SHFMT_OPT_FULL = 							$0001;
   SHFMT_OPT_SYSONLY = 						$0002;
   SHFMT_ID_DEFAULT =						$FFFF;

   BIF_NEWDIALOGSTYLE =						$0040;
   BIF_NONEWFOLDERBUTTON = 				$0200;
   BIF_SHAREABLE =							$8000;
   BIF_UAHINT =								$0100;
   BIF_NOTRANSLATETARGETS =				$0400;
   BIF_BROWSEINCLUDEURLS =					$0080;
   BIF_EDITBOX =								$0010;
   BIF_USENEWUI =                      BIF_EDITBOX or BIF_NEWDIALOGSTYLE;
{-----------------------------------------------------------------------------
 Description: Constants for dwExceptions
-----------------------------------------------------------------------------}
   DW_EXCEPT_MSG_GENERIC = 'Unspecified error occured';
   DW_EXCEPT_MSG_SLISNIL = 'StringList cannot be NIL';

{-----------------------------------------------------------------------------
 Description: Constants for dwFiles
-----------------------------------------------------------------------------}
   SHERB_NOCONFIRMATION = 	$00000001;
   SHERB_NOPROGRESSUI = 	$00000002;
   SHERB_NOSOUND = 			$00000004;

   dwCRC32Table: array[0..255] of DWORD =
                          ($00000000, $77073096, $EE0E612C, $990951BA,
                           $076DC419, $706AF48F, $E963A535, $9E6495A3,
                           $0EDB8832, $79DCB8A4, $E0D5E91E, $97D2D988,
                           $09B64C2B, $7EB17CBD, $E7B82D07, $90BF1D91,
                           $1DB71064, $6AB020F2, $F3B97148, $84BE41DE,
                           $1ADAD47D, $6DDDE4EB, $F4D4B551, $83D385C7,
                           $136C9856, $646BA8C0, $FD62F97A, $8A65C9EC,
                           $14015C4F, $63066CD9, $FA0F3D63, $8D080DF5,
                           $3B6E20C8, $4C69105E, $D56041E4, $A2677172,
                           $3C03E4D1, $4B04D447, $D20D85FD, $A50AB56B,
                           $35B5A8FA, $42B2986C, $DBBBC9D6, $ACBCF940,
                           $32D86CE3, $45DF5C75, $DCD60DCF, $ABD13D59,
                           $26D930AC, $51DE003A, $C8D75180, $BFD06116,
                           $21B4F4B5, $56B3C423, $CFBA9599, $B8BDA50F,
                           $2802B89E, $5F058808, $C60CD9B2, $B10BE924,
                           $2F6F7C87, $58684C11, $C1611DAB, $B6662D3D,
                           $76DC4190, $01DB7106, $98D220BC, $EFD5102A,
                           $71B18589, $06B6B51F, $9FBFE4A5, $E8B8D433,
                           $7807C9A2, $0F00F934, $9609A88E, $E10E9818,
                           $7F6A0DBB, $086D3D2D, $91646C97, $E6635C01,
                           $6B6B51F4, $1C6C6162, $856530D8, $F262004E,
                           $6C0695ED, $1B01A57B, $8208F4C1, $F50FC457,
                           $65B0D9C6, $12B7E950, $8BBEB8EA, $FCB9887C,
                           $62DD1DDF, $15DA2D49, $8CD37CF3, $FBD44C65,
                           $4DB26158, $3AB551CE, $A3BC0074, $D4BB30E2,
                           $4ADFA541, $3DD895D7, $A4D1C46D, $D3D6F4FB,
                           $4369E96A, $346ED9FC, $AD678846, $DA60B8D0,
                           $44042D73, $33031DE5, $AA0A4C5F, $DD0D7CC9,
                           $5005713C, $270241AA, $BE0B1010, $C90C2086,
                           $5768B525, $206F85B3, $B966D409, $CE61E49F,
                           $5EDEF90E, $29D9C998, $B0D09822, $C7D7A8B4,
                           $59B33D17, $2EB40D81, $B7BD5C3B, $C0BA6CAD,
                           $EDB88320, $9ABFB3B6, $03B6E20C, $74B1D29A,
                           $EAD54739, $9DD277AF, $04DB2615, $73DC1683,
                           $E3630B12, $94643B84, $0D6D6A3E, $7A6A5AA8,
                           $E40ECF0B, $9309FF9D, $0A00AE27, $7D079EB1,
                           $F00F9344, $8708A3D2, $1E01F268, $6906C2FE,
                           $F762575D, $806567CB, $196C3671, $6E6B06E7,
                           $FED41B76, $89D32BE0, $10DA7A5A, $67DD4ACC,
                           $F9B9DF6F, $8EBEEFF9, $17B7BE43, $60B08ED5,
                           $D6D6A3E8, $A1D1937E, $38D8C2C4, $4FDFF252,
                           $D1BB67F1, $A6BC5767, $3FB506DD, $48B2364B,
                           $D80D2BDA, $AF0A1B4C, $36034AF6, $41047A60,
                           $DF60EFC3, $A867DF55, $316E8EEF, $4669BE79,
                           $CB61B38C, $BC66831A, $256FD2A0, $5268E236,
                           $CC0C7795, $BB0B4703, $220216B9, $5505262F,
                           $C5BA3BBE, $B2BD0B28, $2BB45A92, $5CB36A04,
                           $C2D7FFA7, $B5D0CF31, $2CD99E8B, $5BDEAE1D,
                           $9B64C2B0, $EC63F226, $756AA39C, $026D930A,
                           $9C0906A9, $EB0E363F, $72076785, $05005713,
                           $95BF4A82, $E2B87A14, $7BB12BAE, $0CB61B38,
                           $92D28E9B, $E5D5BE0D, $7CDCEFB7, $0BDBDF21,
                           $86D3D2D4, $F1D4E242, $68DDB3F8, $1FDA836E,
                           $81BE16CD, $F6B9265B, $6FB077E1, $18B74777,
                           $88085AE6, $FF0F6A70, $66063BCA, $11010B5C,
                           $8F659EFF, $F862AE69, $616BFFD3, $166CCF45,
                           $A00AE278, $D70DD2EE, $4E048354, $3903B3C2,
                           $A7672661, $D06016F7, $4969474D, $3E6E77DB,
                           $AED16A4A, $D9D65ADC, $40DF0B66, $37D83BF0,
                           $A9BCAE53, $DEBB9EC5, $47B2CF7F, $30B5FFE9,
                           $BDBDF21C, $CABAC28A, $53B39330, $24B4A3A6,
                           $BAD03605, $CDD70693, $54DE5729, $23D967BF,
                           $B3667A2E, $C4614AB8, $5D681B02, $2A6F2B94,
                           $B40BBE37, $C30C8EA1, $5A05DF1B, $2D02EF8D);

  COMPRESSION_FORMAT_NONE = 		0;
  COMPRESSION_FORMAT_DEFAULT = 	1;
  FILE_DEVICE_FILE_SYSTEM = 		9;
  METHOD_BUFFERED =       			0;
  FILE_READ_DATA =        			1;
  FILE_WRITE_DATA =       			2;
  FSCTL_SET_COMPRESSION = 			(FILE_DEVICE_FILE_SYSTEM shl 16) or
    										((FILE_READ_DATA or FILE_WRITE_DATA) shl 14) or
                                 (16 shl 2) or
                                 METHOD_BUFFERED;
  PathDelim =							'\';

{-----------------------------------------------------------------------------
 Description: Constants for dwFXSystem
-----------------------------------------------------------------------------}
   DX_PATH = 'SOFTWARE\Microsoft\DirectX';
   GL_PATH = 'SOFTWARE\Microsoft\%OS_VERSION_DATA%\CurrentVersion\OpenGLDrivers\RIVATNT';

{-----------------------------------------------------------------------------
 Description: Constants for dwHardware
-----------------------------------------------------------------------------}
   PF_FLOATING_POINT_PRECISION_ERRATA = 0;
   PF_FLOATING_POINT_EMULATED =         1;
   PF_COMPARE_EXCHANGE_DOUBLE =         2;
   PF_MMX_INSTRUCTIONS_AVAILABLE =      3;
   PF_PPC_MOVEMEM_64BIT_OK =            4;
   PF_ALPHA_BYTE_INSTRUCTIONS =         5;
   PF_XMMI_INSTRUCTIONS_AVAILABLE =     6;
   PF_3DNOW_INSTRUCTIONS_AVAILABLE =    7;
   PF_RDTSC_INSTRUCTION_AVAILABLE =     8;
   PF_PAE_ENABLED =                     9;
   PF_XMMI64_INSTRUCTIONS_AVAILABLE =   10;

{-----------------------------------------------------------------------------
 Description: Constants for dwHTML
-----------------------------------------------------------------------------}
   htAnz = 102;

   htTEXT: array[0..htAnz] of char = (
    '&','<','>', ' ', '', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', '', '', '', '|', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', '', '', '', '', '', '', '', '', '', '', '"', '');

   htHTML: array[0..htAnz] of HTMLstr = (
    '&amp;','&lt;','&gt;',{'&nbsp;',}' ', '&copy;', '&reg;', '&#153;',
    '&laquo;', '&raquo;', '&iexcl;', '&iquest;', '&Agrave;', '&agrave;', '&Aacute;',
    '&aacute;', '&Acirc;', '&acirc;', '&Atilde;', '&atilde;', '&Auml;', '&auml;',
    '&Aring;', '&aring;', '&AElig;', '&aelig;', '&Ccedil;', '&ccedil;', '&ETH;',
    '&eth;', '&Egrave;', '&egrave;', '&Eacute;', '&eacute;', '&Ecirc;', '&ecirc;',
    '&Euml;', '&euml;', '&Igrave;', '&igrave;', '&Iacute;', '&iacute;', '&Icirc;',
    '&icirc;', '&Iuml;', '&iuml;', '&Ntilde;', '&ntilde;', '&Ograve;', '&ograve;',
    '&Oacute;', '&oacute;', '&Ocirc;', '&ocirc;', '&Otilde;', '&otilde;', '&Ouml;',
    '&ouml;', '&Oslash;', '&oslash;', '&Ugrave;', '&ugrave;', '&Uacute;', '&uacute;',
    '&Ucirc;', '&ucirc;', '&Uuml;', '&uuml;', '&Yacute;', '&yacute;', '&yuml;',
    '&THORN;', '&thorn;', '&szlig;', '&sect;', '&para;', '&micro;', '&brvbar;',
    '&plusmn;', '&middot;', '&uml;', '&cedil;', '&ordf;', '&ordm;', '&not;', '&shy;',
    '&macr;', '&def;', '&sup1;', '&sup2;', '&sup3;', '&frac14;', '&frac12;',
    '&frac34;', '&times;', '&divide;', '&cent;', '&pound;', '&curren;', '&yen;',
    '&euro;', '&ldquo;', '&quot;', '&rdquo;');

{-----------------------------------------------------------------------------
 Description: Constants for dwIniFiles
-----------------------------------------------------------------------------}
   NILSTRING = '!>NLNONE<!';

{-----------------------------------------------------------------------------
 Description: Constants for dwMedia
-----------------------------------------------------------------------------}
   DW_MP3_Genres : array[0..146] of string =
    ('Blues','Classic Rock','Country','Dance','Disco','Funk','Grunge',
    'Hip- Hop','Jazz','Metal','New Age','Oldies','Other','Pop','R&B',
    'Rap','Reggae','Rock','Techno','Industrial','Alternative','Ska',
    'Death Metal','Pranks','Soundtrack','Euro-Techno','Ambient',
    'Trip-Hop','Vocal','Jazz+Funk','Fusion','Trance','Classical',
    'Instrumental','Acid','House','Game','Sound Clip','Gospel','Noise',
    'Alternative Rock','Bass','Punk','Space','Meditative','Instrumental Pop',
    'Instrumental Rock','Ethnic','Gothic','Darkwave','Techno-Industrial',
    'Electronic', 'Pop-Folk','Eurodance','Dream','Southern Rock','Comedy',
    'Cult','Gangsta','Top 40','Christian Rap','Pop/Funk','Jungle','Native US',
    'Cabaret','New Wave','Psychadelic','Rave','Showtunes','Trailer','Lo-Fi',
    'Tribal','Acid Punk','Acid Jazz','Polka','Retro','Musical','Rock & Roll',
    'Hard Rock','Folk','Folk-Rock','National Folk','Swing','Fast Fusion',
    'Bebob','Latin','Revival','Celtic','Bluegrass','Avantgarde','Gothic Rock',
    'Progressive Rock','Psychedelic Rock','Symphonic Rock','Slow Rock',
    'Big Band','Chorus','Easy Listening','Acoustic','Humour','Speech','Chanson',
    'Opera','Chamber Music','Sonata','Symphony','Booty Bass','Primus',
    'Porn Groove','Satire','Slow Jam','Club','Tango','Samba','Folklore',
    'Ballad','Power Ballad','Rhytmic Soul','Freestyle','Duet','Punk Rock',
    'Drum Solo','Acapella','Euro-House','Dance Hall','Goa','Drum & Bass',
    'Club-House','Hardcore','Terror','Indie','BritPop','Negerpunk','Polsk Punk',
    'Beat','Christian Gangsta','Heavy Metal','Black Metal','Crossover',
    'Contemporary C','Christian Rock','Merengue','Salsa','Thrash Metal','Anime',
    'JPop','SynthPop');

{-----------------------------------------------------------------------------
 Description: Constants for dwNetwork
-----------------------------------------------------------------------------}
   INTERNET_CONNECTION_MODEM =          $01;
   INTERNET_CONNECTION_LAN =            $02;
   INTERNET_CONNECTION_PROXY =          $04;
   (*following implemented in W2k*)
   INTERNET_RAS_INSTALLED =             $10;
   INTERNET_CONNECTION_OFFLINE =        $20;
   INTERNET_CONNECTION_CONFIGURED =     $40;

   NERR_Success = 							 $0;

   MAX_ADAPTER_DESCRIPTION_LENGTH = 	 128;
 	MAX_ADAPTER_NAME_LENGTH = 				 256;
 	MAX_ADAPTER_ADDRESS_LENGTH = 			 8;

{-----------------------------------------------------------------------------
 Description: Constants for dwRegistry
-----------------------------------------------------------------------------}
   sBaseKey =         '\Software\Microsoft\Windows\CurrentVersion\';
   sRun =             'Run\';
   sRunOnce =         'RunOnce\';
   sRunOnceEx =       'RunOnceEx\';
   sRunServices =     'RunServices\';
   sRunServicesOnce = 'RunServicesOnce\';

   REG_QWORD = 11;
   {$EXTERNALSYM REG_QWORD}
   REG_QWORD_LITTLE_ENDIAN = 12;
   {$EXTERNALSYM REG_QWORD_LITTLE_ENDIAN}
   REG_ANY = [0,1,2,3,4,5,6,7,8,9,10,11,12];
   
{-----------------------------------------------------------------------------
 Description: Constants for dwScreens
-----------------------------------------------------------------------------}
   DISPLAY_DEVICE_ACTIVE =              $00000001;
   DISPLAY_DEVICE_ATTACHED_TO_DESKTOP = $00000001;
   DISPLAY_DEVICE_MULTI_DRIVER =        $00000002;
   DISPLAY_DEVICE_PRIMARY_DEVICE =      $00000004;
   DISPLAY_DEVICE_MIRRORING_DRIVER =    $00000008;
   DISPLAY_DEVICE_VGA_COMPATIBLE =      $00000010;
   DISPLAY_DEVICE_REMOVABLE =           $00000020;
   DISPLAY_DEVICE_MODESPRUNED =         $08000000;
   DISPLAY_DEVICE_REMOTE =              $04000000;
   DISPLAY_DEVICE_DISCONNECT =          $02000000;

   ENUM_CURRENT_SETTINGS =              $FFFFFFFF;
//   ENUM_REGISTRY_SETTINGS =             DWord(-2);
   EDS_RAWMODE =                        $00000002;

	MONITOR_DEFAULTTONULL =      			 $00000000;
	MONITOR_DEFAULTTOPRIMARY =   			 $00000001;
   MONITOR_DEFAULTTONEAREST =   			 $00000002;

  	DMDO_DEFAULT = 							 0;
  	DMDO_90 = 									 1;
  	DMDO_180 = 									 2;
  	DMDO_270 =                           3;

	DMDFO_DEFAULT  = 							 0;
  	DMDFO_STRETCH  = 							 1;
  	DMDFO_CENTER   = 							 2;

  	DM_DISPLAYFIXEDOUTPUT = 				 $20000000;

   CDS_TEST = 									 $00000002;	
   CDS_VIDEOPARAMETERS =					 $00000020;

   VP_COMMAND_GET =							 $0001;

{-----------------------------------------------------------------------------
 Description: Constants for dwWinSystem
-----------------------------------------------------------------------------}
  VER_SUITE_BACKOFFICE =               $00000004;
  VER_SUITE_BLADE =                    $00000400;  //DW1.0.243
  VER_SUITE_COMMUNICATIONS =           $00000008;  //DW1.0.243
  VER_SUITE_DATACENTER =               $00000080;
  VER_SUITE_EMBEDDEDNT =               $00000040;  //DW1.0.243
  VER_SUITE_EMBEDDED_RESTRICTED =      $00000800;  //DW1.0.243
  VER_SUITE_SECURITY_APPLIANCE =			$00001000;  //DW1.1
  VER_SUITE_ENTERPRISE =               $00000002;
  VER_SUITE_PERSONAL =                 $00000200;
  VER_SUITE_SINGLEUSERTS =             $00000100;  //DW1.0.243
  VER_SUITE_SMALLBUSINESS =            $00000001;
  VER_SUITE_SMALLBUSINESS_RESTRICTED = $00000020;
  VER_SUITE_TERMINAL =                 $00000010;

  VER_NT_WORKSTATION =                 $0000001;
  VER_NT_DOMAIN_CONTROLLER =           $0000002;
  VER_NT_SERVER =                      $0000003;

{-----------------------------------------------------------------------------
 Description: HTML CSS Color Constants
              Copyright Microsoft Corporation
              http://msdn.microsoft.com/library/default.asp?url=/workshop/author/dhtml/reference/colors/colors.asp
-----------------------------------------------------------------------------}
  dwclAliceBlue: 					TColor =	$00FFF8F0;
  dwclAntiqueWhite:  			TColor = $00D7EBFA;
  dwclAqua:							TColor = $00FFFF00;
  dwclAquaMarine:					TColor = $00D4FF7F;
  dwclAzure:						TColor = $00FFFFF0;
  dwclBeige:				      TColor = $00DCF5F5;
  dwclBisque:				      TColor = $00C4E4FF;
  dwclBlack:				      TColor = $00000000;
  dwclBlancheDalmond:	      TColor = $00CDEBFF;
  dwclBlue:					      TColor = $00FF0000;
  dwclBlueViolet:			      TColor = $00E22B8A;
  dwclBrown:				      TColor = $002A2AA5;
  dwclBurlyWood:			      TColor = $0087B8DE;
  dwclCadetBlue:			      TColor = $00A09E5F;
  dwclChartreuse:			      TColor = $0000FF7F;
  dwclChocolate:			      TColor = $001E69D2;
  dwclCoral:				      TColor = $00507FFF;
  dwclCornFlowerBlue:	      TColor = $00ED9564;
  dwclCornSilk:			      TColor = $00DCF8FF;
  dwclCrimson:				      TColor = $003C14DC;
  dwclCyan:					      TColor = $00FFFF00;
  dwclDarkBlue:			      TColor =	$008B0000;
  dwclDarkCyan:			      TColor = $008B8B00;
  dwclDarkGoldenRod: 	      TColor =	$000B86B8;
  dwclDarkGray:			      TColor =	$00A9A9A9;
  dwclDarkGreen:			      TColor =	$00006400;
  dwclDarkKhaki:			      TColor = $006BB7BD;
  dwclDarkMagenta:		      TColor =	$008B008B;
  dwclDarkOliveGreen:	      TColor = $002F6B55;
  dwclDarkOrange:			      TColor =	$00008CFF;
  dwclDarkOrchid:			      TColor =	$00CC3299;
  dwclDarkRed:				      TColor =	$0000008B;
  dwclDarkSalmon:			      TColor = $007A96E9;
  dwclDarkSeaGreen:		      TColor =	$008BBC8F;
  dwclDarkSlateBlue:		      TColor =	$008B3D48;
  dwclDarkSlateGray:		      TColor = $004F4F2F;
  dwclDarkTurquoise:		      TColor =	$00D1CE00;
  dwclDarkViolet:			      TColor =	$00D30094;
  dwclDeepPink:			      TColor =	$009314FF;
  dwclDeepSkyBlue:		      TColor =	$00FFBF00;
  dwclDimGray:				      TColor =	$00696969;
  dwclDodgerBlue:			      TColor =	$00FF901E;
  dwclFireBrick:			      TColor =	$002222B2;
  dwclFloralWhite:		      TColor =	$00F0FAFF;
  dwclForrestGreen:		      TColor =	$00228B22;
  dwclFuchsia:				      TColor =	$00FF00FF;
  dwclGainsboro:			      TColor =	$00DCDCDC;
  dwclGhostWhite:			      TColor =	$00FFF8F8;
  dwclGold:					      TColor =	$0000D7FF;
  dwclGoldenRod:			      TColor =	$0020A5DA;
  dwclGray:					      TColor =	$00808080;
  dwclGreen:				      TColor =	$00008000;
  dwclGreenYellow:		      TColor =	$002FFFAD;
  dwclHoneyDew:			      TColor =	$00F0FFF0;
  dwclHotPink:				      TColor =	$00B469FF;
  dwclIndianRed:			      TColor =	$005C5CCD;
  dwclIndigo:				      TColor =	$0082004B;
  dwclIvory:				      TColor =	$00F0FFFF;
  dwclKhaki:				      TColor =	$008CE6F0;
  dwclLavender:			      TColor =	$00FAE6E6;
  dwclLavenderBlush:		      TColor =	$00F5F0FF;
  dwclLawnGreen:			      TColor =	$0000FC7C;
  dwclLemonChiffon:		      TColor =	$00CDFAFF;
  dwclLightBlue:			      TColor =	$00E6D8AD;
  dwclLightCoral:			      TColor =	$008080F0;
  dwclLightCyan:			      TColor =	$00FFFFE0;
  dwclLightGoldenRodYellow:	TColor =	$00D2FAFA;
  dwclLightGreen:					TColor = $0090EE90;
  dwclLightGrey:					TColor =	$00D3D3D3;
  dwclLightPink:					TColor = $00C1B6FF;
  dwclLightSalmon:				TColor = $007AA0FF;
  dwclLightSeaGreen:				TColor = $00AAB220;
  dwclLightSkyBlue:				TColor = $00FACE87;
  dwclLightSlateGray:			TColor = $00998877;
  dwclLightSteelBlue:			TColor = $00DEC4B0;
  dwclLightYellow:				TColor = $00E0FFFF;
  dwclLime:							TColor = $0000FF00;
  dwclLimeGreen:					TColor = $0032CD32;
  dwclLinen:						TColor = $00E6F0FA;
  dwclMagenta:						TColor = $00FF00FF;
  dwclMaroon:						TColor = $00000080;
  dwclMediumAquaMarine:			TColor = $00AACD66;
  dwclMediumBlue:					TColor = $00CD0000;
  dwclMediumOrchid:				TColor = $00D355BA;
  dwclMediumPurple:				TColor = $00DB7093;
  dwclMediumSeaGreen:			TColor = $0071B33C;
  dwclMediumSlateBlue:			TColor = $00EE687B;
  dwclMediumSpringGreen:		TColor = $009AFA00;
  dwclMediumTurquoise:			TColor = $00CCD148;
  dwclMediumVioletRed:			TColor = $008515C7;
  dwclMidnightBlue:				TColor = $00701919;
  dwclMintCream:					TColor = $00FAFFF5;
  dwclMistyRose:					TColor = $00E1E4FF;
  dwclMoccasin:					TColor = $00B5E4FF;
  dwclNavajoWhite:				TColor = $00ADDEFF;
  dwclNavy:							TColor = $00800000;
  dwclOldLace:						TColor = $00E6F5FD;
  dwclOlive:						TColor = $00008080;
  dwclOliveDrab:              TColor = $00238E6B;
  dwclOrange:						TColor = $0000A5FF;
  dwclOrangeRed:					TColor = $000045FF;
  dwclOrchid:						TColor = $00D670DA;
  dwclPaleGoldenRod:				TColor = $00AAE8EE;
  dwclPaleGreen:					TColor = $0098FB98;
  dwclPaleTurquoise:				TColor = $00EEEEAF;
  dwclPaleVioletRed:				TColor = $009370DB;
  dwclPapayaWhip:					TColor = $00D5EFFF;
  dwclPeachPuff:					TColor = $00B9DAFF;
  dwclPeru:							TColor = $003F85CD;
  dwclPink:							TColor = $00CBC0FF;
  dwclPlum:							TColor = $00DDA0DD;
  dwclPowderBlue:					TColor = $00E6E0B0;
  dwclPurple:						TColor = $00800080;
  dwclRed:							TColor = $000000FF;
  dwclRosyBrown: 					TColor = $008F8FBC;
  dwclRoyalBlue:					TColor = $00E16941;
  dwclSaddleBrown: 				TColor = $0013458B;
  dwclSalmon:						TColor = $007280FA;
  dwclSandyBrown:					TColor = $0060A4F4;
  dwclSeaGreen:					TColor = $00578B2E;
  dwclSeaShell:					TColor = $00EEF5FF;
  dwclSienna:						TColor = $002D52A0;
  dwclSilver:						TColor = $00C0C0C0;
  dwclSkyBlue:						TColor = $00EBCE87;
  dwclSlateBlue:					TColor = $00CD5A6A;
  dwclSlateGrey:					TColor = $00908070;
  dwclSnow:							TColor = $00FAFAFF;
  dwclSpringGreen:				TColor = $007FFF00;
  dwclSteelBlue:					TColor = $00B48246;
  dwclTan:							TColor = $008CB4D2;
  dwclTeal:							TColor = $00808000;
  dwclThistle:						TColor = $00D8BFD8;
  dwclTomato:						TColor = $004763FF;
  dwclTurqoise:					TColor = $00D0E040;
  dwclViolet:						TColor = $00EE82EE;
  dwclWheat:						TColor = $00B3DEF5;
  dwclWhite:						TColor = $00FFFFFF;
  dwclWhiteSmoke:					TColor = $00F5F5F5;
  dwclYellow:						TColor = $0000FFFF;
  dwclYellowGreen:				TColor = $0032CD9A;

{-----------------------------------------------------------------------------
 Description: RAL Color Constants
-----------------------------------------------------------------------------}
  dwclRAL1000:                TColor = $0071B4C8; // Grnbeige
  dwclRAL1001:                TColor = $006BA6CA; // Beige
  dwclRAL1002:                TColor = $0056A0CC; // Sandgelb
  dwclRAL1003:                TColor = $0024AEF6; // Signalgelb
  dwclRAL1004:                TColor = $001FA7DC; // Goldgelb
  dwclRAL1005:                TColor = $00198EC0; // Honiggelb
  dwclRAL1006:                TColor = $001B8BDC; // Maisgelb
  dwclRAL1007:                TColor = $001880E6; // Narzissengelb
  dwclRAL1011:                TColor = $0038639F; // Braunbeige
  dwclRAL1012:                TColor = $0032AFD4; // Zitronengelb
  dwclRAL1013:                TColor = $00D2F3F7; // Perlwei
  dwclRAL1014:                TColor = $0090D5EA; // Elfenbein
  dwclRAL1015:                TColor = $00C9F8FF; // Hellelfenbein
  dwclRAL1016:                TColor = $0064FFEB; // Schwefelgelb
  dwclRAL1017:                TColor = $0045B6FF; // Safrangelb
  dwclRAL1018:                TColor = $004FFFFF; // Zinkgelb
  dwclRAL1019:                TColor = $005F73A2; // Graubeige
  dwclRAL1020:                TColor = $00497B9C; // Olivgelb
  dwclRAL1021:                TColor = $002DDCFF; // Rapsgelb
  dwclRAL1023:                TColor = $002AE9FF; // Verkehrsgelb
  dwclRAL1024:                TColor = $003B87B8; // Ockergelb
  dwclRAL1026:                TColor = $0043FFFF; // Leuchtgelb
  dwclRAL1027:                TColor = $002381A6; // Currygelb
  dwclRAL1028:                TColor = $0021B5FF; // Melonengelb
  dwclRAL1032:                TColor = $002EC2FF; // Ginstergelb
  dwclRAL1033:                TColor = $002395FF; // Dahliengelb
  dwclRAL1034:                TColor = $002395FF; // Pastellgelb
  dwclRAL2000:                TColor = $00114BDF; // Gelborange
  dwclRAL2001:                TColor = $00101FBE; // Rotorange
  dwclRAL2002:                TColor = $001019D7; // Blutorange
  dwclRAL2003:                TColor = $00225AFF; // Pastellorange
  dwclRAL2004:                TColor = $001130FF; // Reinorange
  dwclRAL2005:                TColor = $000F86FF; // Leuchtorange
  dwclRAL2007:                TColor = $0035C4FF; // Leucht-Hellorange
  dwclRAL2008:                TColor = $001847FF; // Hellrotorange
  dwclRAL2009:                TColor = $00122DEB; // Verkehrsorange
  dwclRAL2010:                TColor = $001C38D8; // Signalorange
  dwclRAL2011:                TColor = $001D4EEB; // Tieforange
  dwclRAL2012:                TColor = $002D3BE0; // Lachsorange
  dwclRAL3000:                TColor = $001215B1; // Feuerrot
  dwclRAL3001:                TColor = $001313AA; // Signalrot
  dwclRAL3002:                TColor = $000F12A8; // Karminrot
  dwclRAL3003:                TColor = $00101088; // Rubinrot
  dwclRAL3004:                TColor = $0003067C; // Purpurrot
  dwclRAL3005:                TColor = $000B0B59; // Weinrot
  dwclRAL3007:                TColor = $0009092B; // Schwarzrot
  dwclRAL3009:                TColor = $000E105C; // Oxidrot
  dwclRAL3011:                TColor = $000A0B72; // Braunrot
  dwclRAL3012:                TColor = $00515EC7; // Beigerot
  dwclRAL3013:                TColor = $000F15A2; // Tomatenrot
  dwclRAL3014:                TColor = $00504AE4; // Altrosa
  dwclRAL3015:                TColor = $009888EB; // Hellrosa
  dwclRAL3016:                TColor = $001315A1; // Korallenrot
  dwclRAL3017:                TColor = $003228D9; // Ros
  dwclRAL3018:                TColor = $002B22E0; // Erdbeerrot
  dwclRAL3020:                TColor = $000E0FD1; // Verkehrsrot
  dwclRAL3022:                TColor = $00343DDB; // Lachsrot
  dwclRAL3024:                TColor = $001019FF; // Leuchtrot
  dwclRAL3026:                TColor = $000F3CFF; // Leuchthellrot
  dwclRAL3027:                TColor = $001A0FBD; // Himbeerrot
  dwclRAL3031:                TColor = $001711AA; // Orientrot
  dwclRAL4001:                TColor = $00583386; // Rotlila
  dwclRAL4002:                TColor = $0020158C; // Rotviolett
  dwclRAL4003:                TColor = $006234DB; // Erikaviolett
  dwclRAL4004:                TColor = $00110555; // Bourdeauxviolett
  dwclRAL4005:                TColor = $0073397F; // Blaulila
  dwclRAL4006:                TColor = $003F1298; // Verkehrspurpur
  dwclRAL4007:                TColor = $0014073C; // Purpurviolett
  dwclRAL4008:                TColor = $00501F84; // Signalviolett
  dwclRAL4009:                TColor = $00725E98; // Pastellviolett
  dwclRAL4010:                TColor = $004A20CF; // Telemagenta
  dwclRAL5000:                TColor = $00452225; // Violettblau
  dwclRAL5001:                TColor = $003E1F1E; // Grnblau
  dwclRAL5002:                TColor = $00450F14; // Ultramarinblau
  dwclRAL5003:                TColor = $002F141E; // Saphirblau
  dwclRAL5004:                TColor = $000F090B; // Schwarzblau
  dwclRAL5005:                TColor = $00622019; // Signalblau
  dwclRAL5007:                TColor = $00603838; // Brillantblau
  dwclRAL5008:                TColor = $001E141B; // Graublau
  dwclRAL5009:                TColor = $004D2A25; // Azurblau
  dwclRAL5010:                TColor = $00531918; // Enzianblau
  dwclRAL5011:                TColor = $0016090B; // Stahlblau
  dwclRAL5012:                TColor = $00A85247; // Lichtblau
  dwclRAL5013:                TColor = $00260C14; // Kobaltblau
  dwclRAL5014:                TColor = $0079525F; // Taubenblau
  dwclRAL5015:                TColor = $009C4338; // Himmelblau
  dwclRAL5017:                TColor = $00682218; // Verkehrsblau
  dwclRAL5018:                TColor = $00775C42; // Trkisblau
  dwclRAL5019:                TColor = $005D2927; // Capriblau
  dwclRAL5020:                TColor = $0026120F; // Ozeanblau
  dwclRAL5021:                TColor = $005B3D2D; // Wasserblau
  dwclRAL5022:                TColor = $002D0E19; // Nachtblau
  dwclRAL5023:                TColor = $006E3F4D; // Fernblau
  dwclRAL5024:                TColor = $00986E6E; // Pastellblau
  dwclRAL6000:                TColor = $003D493A; // Patinagrn
  dwclRAL6001:                TColor = $001D442E; // Smaragdgrn
  dwclRAL6002:                TColor = $00143527; // Laubgrn
  dwclRAL6003:                TColor = $00172739; // Olivgrn
  dwclRAL6004:                TColor = $001D1918; // Blaugrn
  dwclRAL6005:                TColor = $00131714; // Moosgrn
  dwclRAL6006:                TColor = $00121629; // Grauoliv, ex. Feldgrau
  dwclRAL6007:                TColor = $000E1119; // Flaschengrn
  dwclRAL6008:                TColor = $000C0E1B; // Braungrn
  dwclRAL6009:                TColor = $000F1012; // Tannengrn
  dwclRAL6010:                TColor = $0026493F; // Grasgrn
  dwclRAL6011:                TColor = $00435A5E; // Resedagrn
  dwclRAL6012:                TColor = $0018141F; // Schwarzgrn
  dwclRAL6013:                TColor = $003A4C68; // Schilfgrn
  dwclRAL6014:                TColor = $0012182F; // Gelboliv
  dwclRAL6015:                TColor = $00101121; // Schwarzoliv
  dwclRAL6016:                TColor = $002E3618; // Trkisgrn
  dwclRAL6017:                TColor = $00266446; // Maisgrn
  dwclRAL6018:                TColor = $002F8354; // Gelbgrn
  dwclRAL6019:                TColor = $00ADE2C1; // Weigrn
  dwclRAL6020:                TColor = $00141D23; // Chromoxidgrn
  dwclRAL6021:                TColor = $005F8880; // Blagrn
  dwclRAL6022:                TColor = $000C1023; // Braunoliv
  dwclRAL6024:                TColor = $00446333; // Verkehrsgrn
  dwclRAL6025:                TColor = $00214B46; // Farngrn
  dwclRAL6026:                TColor = $0030230F; // Opalgrn
  dwclRAL6027:                TColor = $00B5AC87; // Lichtgrn
  dwclRAL6028:                TColor = $001F2525; // Kiefergrn
  dwclRAL6029:                TColor = $002B3B18; // Minzgrn
  dwclRAL6032:                TColor = $003B522E; // Signalgrn
  dwclRAL6033:                TColor = $00635F4C; // Minttrkis
  dwclRAL6034:                TColor = $00A49880; // Pastelltrkis
  dwclRAL7000:                TColor = $006A5F75; // Fehgrau
  dwclRAL7001:                TColor = $007F7287; // Silbergrau
  dwclRAL7002:                TColor = $00415174; // Olivgrau
  dwclRAL7003:                TColor = $00404A68; // Moosgrau
  dwclRAL7004:                TColor = $00827A97; // Signalgrau
  dwclRAL7005:                TColor = $0043435C; // Mausgrau
  dwclRAL7006:                TColor = $00353A62; // Beigegrau
  dwclRAL7008:                TColor = $00203862; // Khakigrau
  dwclRAL7009:                TColor = $002C3045; // Grngrau
  dwclRAL7010:                TColor = $00373750; // Zeltgrau
  dwclRAL7011:                TColor = $00342C41; // Eisengrau
  dwclRAL7012:                TColor = $003A3149; // Basaltgrau
  dwclRAL7013:                TColor = $001F2441; // Braungrau
  dwclRAL7015:                TColor = $00312741; // Schiefergrau
  dwclRAL7016:                TColor = $001C182A; // Anthrazitgrau
  dwclRAL7021:                TColor = $001A162D; // Schwarzgrau
  dwclRAL7022:                TColor = $001F1F38; // Umbragrau
  dwclRAL7023:                TColor = $004E5370; // Betongrau
  dwclRAL7024:                TColor = $00241C33; // Graphitgrau
  dwclRAL7026:                TColor = $001E1A2A; // Granitgrau
  dwclRAL7030:                TColor = $00666B88; // Steingrau
  dwclRAL7031:                TColor = $00463E51; // Blaugrau
  dwclRAL7032:                TColor = $0096A8BB; // Kieselgrau
  dwclRAL7033:                TColor = $00525970; // Zementgrau
  dwclRAL7034:                TColor = $004F6686; // Gelbgrau
  dwclRAL7035:                TColor = $00D2CDD7; // Lichtgrau
  dwclRAL7036:                TColor = $00747092; // Platingrau
  dwclRAL7037:                TColor = $00585572; // Staubgrau
  dwclRAL7038:                TColor = $00A0A3B5; // Achatgrau
  dwclRAL7039:                TColor = $003A3C5D; // Quarzgrau
  dwclRAL7040:                TColor = $0095839C; // Fenstergrau
  dwclRAL7042:                TColor = $006D6B84; // Verkehrsgrau A
  dwclRAL7043:                TColor = $00242339; // Verkehrsgrau B
  dwclRAL7044:                TColor = $0099A0BA; // Seidengrau
  dwclRAL7045:                TColor = $00746C86; // Telegrau 1
  dwclRAL7046:                TColor = $00665D73; // Telegrau 2
  dwclRAL7047:                TColor = $00D2C6D7; // Telegrau 4
  dwclRAL8000:                TColor = $001F3E74; // Grnbraun
  dwclRAL8001:                TColor = $0013378D; // Ockerbraun
  dwclRAL8002:                TColor = $001C2466; // Signalbraun
  dwclRAL8003:                TColor = $0013246B; // Lehmbraun
  dwclRAL8004:                TColor = $0019217F; // Kupferbraun
  dwclRAL8007:                TColor = $00101F5B; // Rehbraun
  dwclRAL8008:                TColor = $0015255D; // Olivbraun
  dwclRAL8011:                TColor = $00111446; // Nubraun
  dwclRAL8012:                TColor = $00100F52; // Rotbraun
  dwclRAL8014:                TColor = $000C112D; // Sepiabraun
  dwclRAL8015:                TColor = $000B0E4F; // Kastanienbraun
  dwclRAL8016:                TColor = $000C0C38; // Mahagonibraun
  dwclRAL8017:                TColor = $000B0A2A; // Schokoladenbraun
  dwclRAL8019:                TColor = $00110E23; // Graubraun
  dwclRAL8022:                TColor = $0009050B; // Schwarzbraun
  dwclRAL8023:                TColor = $00162E98; // Orangebraun
  dwclRAL8024:                TColor = $001B2666; // Beigebraun
  dwclRAL8025:                TColor = $00252E62; // Blabraun
  dwclRAL8028:                TColor = $000B1037; // Terrabraun
  dwclRAL9001:                TColor = $00F6FFFF; // Cremewei
  dwclRAL9002:                TColor = $00EAEDF0; // Grauwei
  dwclRAL9003:                TColor = $00FFFFFF; // Signalwei
  dwclRAL9004:                TColor = $0007070F; // Signalschwarz
  dwclRAL9005:                TColor = $00000000; // Tiefschwarz

  
implementation

end.
