{-----------------------------------------------------------------------------
                          ---> Project DelphiWorks <---
                                   Version 1.3
 -----------------------------------------------------------------------------
 Unit:        dwMedia.pas
 Description: Multimedia tools
 Author:      Codehunter Works
 Release:     1.3
 State:       Stable
 Date:        16.08.2004
 Created:     14.12.2002
 Last mod.:   16.08.2004
 History:     n/a
-----------------------------------------------------------------------------}


unit dwMedia;

interface

uses dwTypes;

function dwGenreByteToName(const Genre: Byte): String;
function dwReadID3V1Tag(FileName: string): TID3V1Tag;

procedure dwBuzzerSound(const Frequency: Word; const Delay: Cardinal);

implementation

uses dwConsts, dwInternal, dwWinSystem,
     Classes, SysUtils, Windows;

function dwGenreByteToName(const Genre: Byte): String;
begin
   result:= DW_MP3_Genres[Genre];
end;

function dwReadID3V1Tag(FileName: string): TID3V1Tag;
var
  FS: TFileStream;
  Buffer: array [1..128] of Char;
begin
  FS := TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
  try
    FS.Seek(-128, soFromEnd);
    FS.Read(Buffer, 128);
    with Result do
    begin
      ID      := Copy(Buffer, 1, 3);
      Titel   := Copy(Buffer, 4, 30);
      Artist  := Copy(Buffer, 34, 30);
      Album   := Copy(Buffer, 64, 30);
      Year    := Copy(Buffer, 94, 4);
      Comment := Copy(Buffer, 98, 30);
      Genre   := Ord(Buffer[128]);
    end;
  finally
    FS.Free;
  end;
end;

{-----------------------------------------------------------------------------
 Procedures
-----------------------------------------------------------------------------}
procedure dwBuzzerSound(const Frequency: Word; const Delay: Cardinal);
begin
 if dwIsNTMachine then
   Beep(Frequency, Delay) else
 begin
   dwSound(Frequency);
   Sleep(Delay);
   dwNoSound;
 end;
end;

end.
 