{-----------------------------------------------------------------------------
                          ---> Project DelphiWorks <---
                                   Version 1.3
 -----------------------------------------------------------------------------
 Unit:        dwMemory.pas
 Description: System memory functions
 Author:      Codehunter Works
 Release:     1.3
 State:       Stable
 Date:        16.08.2004
 Created:     14.12.2002
 Last mod.:   16.08.2004
 History:     n/a
-----------------------------------------------------------------------------}
unit dwMemory;

interface

function dwAvailablePageMemory: Int64;
function dwAvailablePhysicalMemory: Int64;
function dwAvailableVirtualMemory: Int64;
function dwMemoryUsedPercentage: Integer;
function dwTotalPageMemory: Int64;
function dwTotalPhysicalMemory: Int64;
function dwTotalVirtualMemory: Int64;

implementation

uses dwInternal;

function dwAvailablePageMemory: Int64;
begin
   result:= dwGetMemData.dwAvailPageFile;
end;

function dwAvailablePhysicalMemory: Int64;
begin
   result:= dwGetMemData.dwAvailPhys;
end;

function dwAvailableVirtualMemory: Int64;
begin
   result:= dwGetMemData.dwAvailVirtual;
end;

function dwMemoryUsedPercentage: Integer;
begin
   result:= dwGetMemData.dwMemoryLoad;
end;

function dwTotalPageMemory: Int64;
begin
   result:= dwGetMemData.dwTotalPageFile;
end;

function dwTotalPhysicalMemory: Int64;
begin
   result:= dwGetMemData.dwTotalPhys;
end;

function dwTotalVirtualMemory: Int64;
begin
   result:= dwGetMemData.dwTotalVirtual;
end;

end.
