{-----------------------------------------------------------------------------
                          ---> Project DelphiWorks <---
                                   Version 1.3
 -----------------------------------------------------------------------------
 Unit:        dwTypes.pas
 Description: Types and declarations for DelphiWorks
 Author:      Codehunter Works
 Release:     1.3
 State:       Stable
 Date:        16.08.2004
 Created:     14.12.2002
 Last mod.:   16.08.2004
 History:     n/a
-----------------------------------------------------------------------------}
unit dwTypes;

interface

uses  dwConsts,
		Windows;

type

{-----------------------------------------------------------------------------
 Description: Declarations for dwColor
-----------------------------------------------------------------------------}
  TDWUseLightDarkColor = (dwuldcLight, dwuldcDark);	

{-----------------------------------------------------------------------------
 Description: Declarations for dwDateTime
-----------------------------------------------------------------------------}
  TDWHoliday = (dwhdAdvent1,
                dwhdAdvent2,
                dwhdAdvent3,
                dwhdAdvent4,
                dwhdBussUndBetTag,
                dwhdErntedankfest,
                dwhdFronleichnam,
                dwhdHeiligabend,
                dwhdHimmelfahrt,
                dwhdKarfreitag,
                dwhdNeujahr,
                dwhdOstermontag,
                dwhdOsterSonntag,
                dwhdPfingstmontag,
                dwhdPfingstsonntag,
                dwhdReformationstag,
                dwhdSilvester,
                dwhdTagDerArbeit,
                dwhdTagDerDeutschenEinheit,
                dwhdUnknown,
                dwhdValentinstag,
                dwhdWeihnachtsfeiertag1,
                dwhdWeihnachtsfeiertag2);

{-----------------------------------------------------------------------------
 Description: Declarations for dwDialogs
-----------------------------------------------------------------------------}
  TDWWindowsDialog = (dwwdAccessibilityProperties,
                      dwwdBDEProperties,
                      dwwdControlPanel,
                      dwwdCopyFloppy,
                      dwwdDialProperties,
                      dwwdDisplayProperties,
                      dwwdExecute,
                      dwwdFindFiles,
                      dwwdFontsProperties,
                      dwwdGamecontrollerProperties,
                      dwwdHardwareDetect,
                      dwwdInternetProperties,
                      dwwdKeyboardProperties,
                      dwwdLocaleProperties,
                      dwwdMailProperties,
                      dwwdModemProperties,
                      dwwdMouseProperties,
                      dwwdMultimediaProperties,
                      dwwdNetworkProperties,
                      dwwdODBCProperties,
                      dwwdPasswordsProperties,
                      dwwdPowerManagementProperties,
                      dwwdPrinterProperties,
                      dwwdRASWizard,
                      dwwdRecycleBin,
                      dwwdRunFile,
                      dwwdScanCamProperties,
                      dwwdScreenSaver,
                      dwwdSoftwareProperties,
                      dwwdStartMenu,
                      dwwdSystemProperties,
                      dwwdThemesProperties,
                      dwwdTime,
                      dwwdTweakUIProperties,
                      dwwdUserManager,
                      dwwdWindowsAboutDlg,
                      dwwdWindowsShutdownDialog);

  TDWFmtDriveDlgCapacity = (dwfddcDefault,
                            dwfddc1_44M,
                            dwfddc720K,
                            dwfddcMakeBoot);

{-----------------------------------------------------------------------------
 Description: Declarations for dwDrives
-----------------------------------------------------------------------------}
  TDWDriveShellInfo = packed record
     Icon : hIcon;
     Image : integer;
     DisplayName,
     TypeName : string
  end;

  TDWEjectRemovableResult = (dwejeUnsupported,
                             dwejeVolumeLocked,
                             dwejeUnremovable,
                             dwejeRequestFailed,
                             dwejeAllReady);

  TDiocRegisters = record
    EBX, EDX, ECX, EAX, EDI, ESI, Flags: DWORD;
  end;

  TVWin32CtlCode = (ccNone, ccVWin32IntIoctl, ccVWin32Int26,
    ccVWin32Int25, ccVWin32Int13);

  TBiosParamBlock = packed record
    { Test Bla bla }
    BytesPerSector: Word;
    SectorsPerCluster: Byte;
    ReservedSectors: Word;
    NumFats: Byte;
    NumRootEntries: Word;
    NumSectors: Word;
    MediaID: Byte;
    SectorsPerFat: Word;
    SectorsPerTrack: Word;
    NumHeads: Word;
    HiddenSectors: Word;
    Dummy1: Word;
    TotalSectors: LongInt;
    Dummy2: array[0..5] of Byte;
  end;

  TDeviceParamBlock = packed record
    Special: Byte;
    DeviceType: Byte;
    DeviceAttr: Word;
    NumCylinders: Word;
    MediaType: Byte;
    BiosParamBlock: TBiosParamBlock;
  end;

  TFormatParamBlock = packed record
    Reserved: Byte;
    Head: Word;
    Cylinder: Word;
  end;

  TDriveInformation = record
     VolumeName  : string;
     VolumeSerialNumber,
     MaximumComponentLength,
     FileSystemFlags : DWord;
     FileSystemName : string;
  end;

  TDiskGeometry = record
     Cylinders: Integer;
     MediaType: Integer;
     TracksPerCylinder: DWord;
     SectorsPerTrack: DWord;
     BytesPerSector: DWord;
  end;

{-----------------------------------------------------------------------------
 Description: Declarations for dwExceptions
-----------------------------------------------------------------------------}
  TDWException = (dwexcptGeneric,
                  dwexcptStringList);

{-----------------------------------------------------------------------------
 Description: Declarations for dwFiles
-----------------------------------------------------------------------------}
  TDWFileDateTimeStamp = packed record
     Creation,
     LastWrite: TDateTime;
  end;

  TSHEmptyRecycleBin = function(Wnd: HWND;
                                pszRootPath: PChar;
                                dwFlags: DWORD): HRESULT;  stdcall;

  TDWIconType = (dwitSmall, dwitLarge, dwitShellSetting);	

{-----------------------------------------------------------------------------
 Description: Declarations for dwFXSystem
-----------------------------------------------------------------------------}
  TDWDirectXVersion = packed record
    MajorVersion,
    MinorVersion,
    BuildVersion:        Integer;
    FullVersionAsString: String;
  end;

  TDWOpenGLVersion = packed record
    DriverName,
    DriverVersion,
    GLVersion:            String;
  end;

{-----------------------------------------------------------------------------
 Description: Declarations for dwHTML
-----------------------------------------------------------------------------}
  HTMLstr = string[8];

{-----------------------------------------------------------------------------
 Description: Declarations for dwHardware
-----------------------------------------------------------------------------}
  BLUETOOTH_ADRESS = record
  	 BTH_ADDR:				  LongWord;
    rgBytes:				  Array[0..5] of Byte;
  end;

  BLUETOOTH_DEVICE_INFO = record
    dwSize: 				  DWord;
    Adress:					  BLUETOOTH_ADRESS;
    ulClassofDevice:		  LongWord;
    fConnected,
    fRemembered,
    fAuthenticated:		  Boolean;
    stLastSeen,
    stLastUsed:			  SYSTEMTIME;
    szName:					  WCHAR;
  end;

  BLUETOOTH_DEVICE_SEARCH_PARAMS = record
  	 dwSize:					  DWord;
    fReturnAuthenticated,
    fReturnRemembered,
    fReturnUnknown,
    fReturnConnected,
    fIssueInquiry:		  Boolean;
    cTimeoutMultiplier:	  Byte;
    hRadio:					  THandle;	
  end;

  BLUETOOTH_COD_PAIRS = record
  	 ulCODMask:				  LongWord;
    pcszDescription:		  PChar;
  end;

  BLUETOOTH_FIND_RADIO_PARAMS = record
  	 dwSize:					  DWord;
  end;

  BLUETOOTH_RADIO_INFO = record
  	 dwSize:					  DWord;
    adress:					  BLUETOOTH_ADRESS;
    szName:					  WCHAR;
    ulClassofDevice:		  LongWord;
    lmpSubversion,
    manufacturer:			  Byte;
  end;

  PFN_DEVICE_CALLBACK = function(var pvParam; pDevice: BLUETOOTH_DEVICE_INFO): Boolean;

  BLUETOOTH_SELECT_DEVICE_PARAMS = record
    dwSize:					  DWord;
    cNumOfClasses:		  LongWord;
    prgClassOfDevices:	  ^BLUETOOTH_COD_PAIRS;
    pszInfo:				  PChar;
    hwndParent:			  HWND;
    fForceAuthentication,
    fShowAuthenticated,
    fShowRemembered,
    fShowUnknown,
    fAddNewDeviceWizard,
    fSkipServicesPage:	  Boolean;
    pfnDeviceCallback:	  PFN_DEVICE_CALLBACK;
    pvParam:				  Pointer;
    pDevices:				  ^BLUETOOTH_DEVICE_INFO;
  end;

{-----------------------------------------------------------------------------
 Description: Declarations for dwMedia
-----------------------------------------------------------------------------}
  TID3V1Tag = record
    ID: string[3];
    Titel: string[30];
    Artist: string[30];
    Album: string[30];
    Year: string[4];
    Comment: string[30];
    Genre: Byte;
  end;

{-----------------------------------------------------------------------------
 Description: Declarations for dwNetwork
-----------------------------------------------------------------------------}
  TDWHostConnectInfo = packed record
     Host: String;
     Port: Word;
  end;

  TDWInternetConnectedState = (dwicsConfigured,
                               dwicsLAN,
                               dwicsModem,
                               dwicsOffline,
                               dwicsProxy,
                               dwicsRASInstalled);

  TDWInternetConnectedStates = set of TDWInternetConnectedState;

  TDWInternetProxySetting = packed record
     HTTP,
     HTTPS,
     FTP,
     Gopher,
     Socks: TDWHostConnectInfo;
  end;

  TDWServiceState = (dwsstContinuePending,
                     dwsstErrorOpeningService,
                     dwsstStartPending,
                     dwsstServiceNotFound,
                     dwsstStopped,
                     dwsstStopPending,
                     dwsstPaused,
                     dwsstPausePending,
                     dwsstRunning,
                     dwsstUnknown);

  	PIP_ADDRESS_STRING = ^IP_ADDRESS_STRING;
  	IP_ADDRESS_STRING = packed record
     	acString: array [1..16] of Char;
  	end;

  	PIP_MASK_STRING = ^PIP_MASK_STRING;
  	IP_MASK_STRING = IP_ADDRESS_STRING;

  	PIP_ADDR_STRING = ^IP_ADDR_STRING;
  	IP_ADDR_STRING = packed record
     	Next: 		PIP_ADDR_STRING;
     	IpAddress: 	IP_ADDRESS_STRING;
     	IpMask: 		IP_MASK_STRING;
     	Context: 	DWORD;
  end;

  time_t = int64;

  PIP_ADAPTER_INFO = ^IP_ADAPTER_INFO;
  IP_ADAPTER_INFO = packed record
   	Next:						PIP_ADAPTER_INFO;
   	ComboIndex: 			DWORD;
   	AdapterName: 			array [1..MAX_ADAPTER_NAME_LENGTH+4] of Char;
   	Description: 			array [1..MAX_ADAPTER_DESCRIPTION_LENGTH+4] of Char;
   	AddressLength: 		UINT;
   	Address: 				array [1..MAX_ADAPTER_ADDRESS_LENGTH] of Byte;
   	Index: 					DWORD;
   	dwType: 					UINT;
   	DhcpEnabled: 			UINT;
   	CurrentIpAddress:		PIP_ADDR_STRING;
   	IpAddressList: 		IP_ADDR_STRING;
   	GatewayList: 			IP_ADDR_STRING;
   	DhcpServer: 			IP_ADDR_STRING;
   	HaveWins: 				Boolean;
   	PrimaryWinsServer:	IP_ADDR_STRING;
   	SecondaryWinsServer: IP_ADDR_STRING;
  		LeaseObtained:			time_t;
   	LeaseExpires: 			time_t;
  end;

{-----------------------------------------------------------------------------
 Description: Declarations for dwRegistry
-----------------------------------------------------------------------------}
  TDWAutorunRootKey = (dwarkHKCU,
                       dwarkHKLM);

  TDWAutorunOption  = (dwaoRun,
                       dwaoRunOnce,
                       dwaoRunOnceEx,
                       dwaoRunServices,
                       dwaoRunServicesOnce);

  TDWRegValueType   = (dwrvtAny,
                       dwrvtBinary,
                       dwrvtDWord,
                       dwrvtDWordBigEndian,
                       dwrvtDWordLittleEndian,
                       dwrvtExpandSZ,
                       dwrvtFullResourceDescriptor,
                       dwrvtLink,
                       dwrvtMultiSZ,
  							  dwrvtNone,
                       dwrvtQWord,
                       dwrvtQWordLittleEndian,
                       dwrvtResourceList,
                       dwrvtResourceRequirementsList,
                       dwrvtSZ);  

//  TDWRegFcnReturnCode = (dwrfc

{-----------------------------------------------------------------------------
 Description: Declarations for dwScreens
-----------------------------------------------------------------------------}
  {$EXTERNALSYM HMONITOR}
  HMONITOR = type Integer;

//  {$EXTERNALSYM MonitorFromPoint}
  MonitorFromPoint = function(ptScreenCoords: TPoint; dwFlags: DWORD): HMONITOR; stdcall;
  TDWMonitorInfoEx = record
	  cbSize:		DWord;
     rcMonitor:	TRect;
     rcWork:		TRect;
     dwFlags:		DWord;
     szService:	array[0..CCHDEVICENAME - 1] of AnsiChar;
  end;

  TDWDisplayOrientation = (dwdoPortrait,     //W95..ME and NT4..2K
                          dwdoLandscape,    //W95..ME and NT4..2K
                          dwdoDefault,		  //XP
                          dwdo90Degrees,    //XP
                          dwdo180Degrees,   //XP
                          dwdo270Degrees);  //XP

  TDWFixedResolutionMode = (dwfrmDefault,
                            dwfrmCenter,
                            dwfrmStretch); 	

  TDWScreenMode = record
     XResolution,
     YResolution,
     BitDepth,
     Frequency: Integer;
     Grayscale,
     Interlaced: Boolean;
     Orientation: TDWDisplayOrientation;
  end;

  TDWScreenModeList = array of TDWScreenMode;

{-----------------------------------------------------------------------------
 Description: Declarations for dwWinSystem
-----------------------------------------------------------------------------}
  TDWBootOption = (dwboNormal,        //Normaler Systemstart
                   dwboFailSafe,      //Abgesicherter Modus
                   dwboFailSaveNet);  //Abgesicherter Modus mit Netzwerk

  TDWComPort  =   (dwcptCOM1,
                   dwcptCOM2,
                   dwcptCOM3,
                   dwcptCOM4,
                   dwcptCOM5,
                   dwcptCOM6,
                   dwcptCOM7,
                   dwcptUnknown);

  TDWDimension  = packed record
                   Height,
                   Width:              Integer;
  end;

  TDWFileFlags  = (dwffDebug,
                   dwffInfoInferred,
                   dwffPatched,
                   dwffPrerelease,
                   dwffPrivateBuild,
                   dwffSpecialBuild);

  TDWFileInfo = packed record
                   dwSignature:        DWORD;
                   dwStrucVersion:     DWORD;
                   dwFileVersionMS:    DWORD;
                   dwFileVersionLS:    DWORD;
                   dwProductVersionMS: DWORD;
                   dwProductVersionLS: DWORD;
                   dwFileFlagsMask:    DWORD;
                   dwFileFlags:        DWORD;
                   dwFileOS:           DWORD;
                   dwFileType:         DWORD;
                   dwFileSubtype:      DWORD;
                   dwFileDateMS:       DWORD;
                   dwFileDateLS:       DWORD;
                   dwFileLanguage:     Word;
                   dwFileCharSet:      Word;
                   dwComments,
                   dwCompanyName,
                   dwFileDescription,
                   dwFileVersion,
                   dwInternalName,
                   dwLegalCopyright,
                   dwLegalTrademarks,
                   dwOriginalFilename,
                   dwPrivateBuild,
                   dwProductName,
                   dwProductVersion,
                   dwSpecialBuild:     String;
  end;

  TDWFileOS     = (dwfosDOS,
                   dwfosDOS_Windows16,
                   dwfosDOS_Windows32,
                   dwfosNT,
                   dwfosNT_Windows32,
                   dwfosWindows16,
                   dwfosWindows32,
                   dwfosOS2_16,
                   dwfosOS2_16_PM16,
                   dwfosOS2_32,
                   dwfosOS2_32_PM32,
                   dwfosPM16,
                   dwfosPM32,
                   dwfosUnknown);

  TDWFileOSSet   = Set of TDWFileOS;

  TDWFileSubType= (dwfstCOMM,
                   dwfstDisplay,
                   dwfstFontRaster,
                   dwfstFontTruetype,
                   dwfstFontVector,
                   dwfstInstallable,
                   dwfstKeyboard,
                   dwfstLanguage,
                   dwfstMouse,
                   dwfstNetwork,
                   dwfstPrinter,
                   dwfstSound,
                   dwfstSystem,
                   dwfstUnknown,
                   dwfstVersionedPrinter);

  TDWFileType   = (dwftApp,
                   dwftDLL,
                   dwftDRV,
                   dwftFont,
                   dwftStaticLib,
                   dwftUnknown,
                   dwftVXD);

  TDWFixedFileInfo = packed record
                   dwSignature:        DWORD;
                   dwStrucVersion:     DWORD;
                   dwFileVersionMS:    DWORD;
                   dwFileVersionLS:    DWORD;
                   dwProductVersionMS: DWORD;
                   dwProductVersionLS: DWORD;
                   dwFileFlagsMask:    DWORD;
                   dwFileFlags:        DWORD;
                   dwFileOS:           DWORD;
                   dwFileType:         DWORD;
                   dwFileSubtype:      DWORD;
                   dwFileDateMS:       DWORD;
                   dwFileDateLS:       DWORD;
  end;

  TDWLangCharSet = packed record
                   dwLang,
                   dwCharSet:          Word;
  end;

  TDWMenuAlignment =
                  (dwmaLeft,          //Men links unter MenuItem
                   dwmaRight);        //Men rechts unter MenuItem

  TDWMinimizedWindowArrangement =
                  (dwmwaBottomLeft,   //Unten links
                   dwmwaBottomRight,  //Unten rechts
                   dwmwaHide,         //Verborgen ( auerhalb sichtbarer Bereich )
                   dwmwaTopLeft,      //Open links
                   dwmwaTopRight);    //Oben rechts

  TDWProcessorFeature =
                  (dwpft3DNow,
                   dwpftDoubleExchange,
                   dwpftFloatingError,
                   dwpftMMX,
                   dwpftPAE,
                   dwpftPointEmulated,
                   dwpftRDTSC,
                   dwpftSSE,
                   dwpftSSE2);

  TDWProcessorFeatures = set of TDWProcessorFeature;

  TDWProcessorType =
                  (dwptpAlpha,
                   dwptpAMD64,
                   dwptpIA32onWin64,
                   dwptpIA64,
                   dwptpIntel,
                   dwptpMIPS,
                   dwptpPPC,
                   dwptpUnkknown);

  TDWScreenType = (dwscrtAll,           //Jeder Bildschirm
                   dwscrtDesktop,       //Alle, die ein Teil des Desktops sind
                   dwscrtMirror,        //Alle, die einen Bildschirm spiegeln
                   dwscrtModeSpruned,   //Grafikkarte kann mehr als der Monitor
                   dwscrtPrimary,       //Primre Grafikkarte
                   dwscrtRemovable,     //Auswechselbare
                   dwscrtVGA);          //VGA-kompatible

  TDWScreenTypes = set of TDWScreenType;

  TDWSpecialFolder = (dwspfAdminTools,
                      dwspfAppData,
                      dwspfRecycleBin,
                      dwspfCommonAdminTools,
                      dwspfCommonAppData,
                      dwspfCommonDesktop,
                      dwspfCommonDocuments,
                      dwspfCommonFavorites,
                      dwspfCommonMusic,
                      dwspfCommonPictures,
                      dwspfCommonProgramFiles,
                      dwspfCommonPrograms,
                      dwspfCommonStartmenu,
                      dwspfCommonStartup,
                      dwspfCommonTemplates,
                      dwspfCommonVideo,
                      dwspfControls,
                      dwspfCookies,
                      dwspfDesktop,
                      dwspfDrives,
                      dwspfFavorites,
                      dwspfFonts,
                      dwspfHistory,
                      dwspfInternetCache,
                      dwspfLocalAppData,
                      dwspfMyMusic,
                      dwspfMyPictures,
                      dwspfMyVideo,
                      dwspfNetHood,
                      dwspfNetwork,
                      dwspfPersonal,
                      dwspfPrinters,
                      dwspfPrintHood,
                      dwspfProfile,
                      dwspfProgramFiles,
                      dwspfProgramFilesX86,
                      dwspfPrograms,
                      dwspfRecent,
                      dwspfSendTo,
                      dwspfStartMenu,
                      dwspfStartUp,
                      dwspfSystem,
                      dwspfSystemX86,
                      dwspfTempDir,
                      dwspfTemplates,
                      dwspfWindows);

  TDWACLineStatus = (dwalsOffline,
                     dwalsOnline,
                     dwalsUnknownState);

  TDWBatteryState = (dwbtsHigh,
                     dwbtsLow,
                     dwbtsCritical,
                     dwbtsCharging,
                     dwbtsNoSystemBattery,
                     dwbtsUnknownState);

  TDWBatteryStates = set of TDWBatteryState;

  TDWVersionBlock = packed record
                     dwVersionMajor,
                     dwVersionMinor:     Integer;
  end;

  TDWVersionBlockEx = packed record
      					dwVersionMajor,
                     dwVersionMinor,
                     dwBuildMajor,
                     dwBuildMinor: Integer;
                     AsString,
                     SuiteName: String;
  end;

  POINTL = packed record
    x,
    y: Longint;
  end;

(*  _devicemodeA_0500 = {packed} record // not sure about packed ... should be but ty with getlasterror
    dmDeviceName: array[0..CCHDEVICENAME - 1] of char;
    dmSpecVersion,
      dmDriverVersion,
      dmSize,
      dmDriverExtra: Word;
    dmFields: DWORD;
    case integer of
      0: (dmOrientation,
        dmPaperSize,
        dmPaperLength,
        dmPaperWidth,
        dmScale,
        dmCopies,
        dmDefaultSource,
        dmPrintQuality: Shortint;
        );
      1: (
        dmPosition: POINTL;
        dmDisplayOrientation,
        dmDisplayFixedOutput: DWORD; // end union
        dmColor,
        dmDuplex,
        dmYResolution,
        dmTTOption,
        dmCollate: shortint;
        dmFormName: array[0..CCHFORMNAME] of Char; //resp. byte
        dmLogPixels: WORD;
        dmBitsPerPel,
        dmPelsWidth,
        dmPelsHeight: DWORD;
        case integer of
          0: (dmDisplayFlags: DWORD);
          1: (dmNup: DWORD; // end union
            dmDisplayFrequency: DWORD;
{$IFDEF WINVER400} // win95+
            dmICMMethod,
            dmICMIntent,
            dmMediaType,
            dmDitherType,
            dmReserved1,
            dmReserved2: DWORD;
{$IFDEF WINVER500} // win98+ and win2000+
            dmPanningWidth,
            dmPanningHeight: DWORD;
{$ENDIF WINVER500}
{$ENDIF WINVER400}
            ); // end union 2 syntactically
          ); // end union 1 syntactically
  end;

  TDmPaperUnion = record
    case Integer of
      0: (
        dmOrientation: Shortint;
        dmPaperSize: Shortint;
        dmPaperLength: Shortint;
        dmPaperWidth: Shortint);
      1: (
        dmPosition: POINTL);
  end;

  TDmDisplayFlagsUnion = record
    case Integer of
      0: (
        dmDisplayFlags: DWORD);
      1: (
        dmNup: DWORD);
  end;

  _devicemodeA_0500 = record
    dmDeviceName: array [0..CCHDEVICENAME - 1] of BYTE;
    dmSpecVersion: WORD;
    dmDriverVersion: WORD;
    dmSize: WORD;
    dmDriverExtra: WORD;
    dmFields: DWORD;
    dmPaperUnion: TDmPaperUnion;
    dmScale: Shortint;
    dmCopies: Shortint;
    dmDefaultSource: Shortint;
    dmPrintQuality: Shortint;
    dmColor: Shortint;
    dmDuplex: Shortint;
    dmYResolution: Shortint;
    dmTTOption: Shortint;
    dmCollate: Shortint;
    dmFormName: array [0..CCHFORMNAME - 1] of BYTE;
    dmLogPixels: WORD;
    dmBitsPerPel: DWORD;
    dmPelsWidth: DWORD;
    dmPelsHeight: DWORD;
    dmDisplayFlags: TDmDisplayFlagsUnion;
    dmDisplayFrequency: DWORD;
    {$IFDEF WINVER_0400_GREATER}
    dmICMMethod: DWORD;
    dmICMIntent: DWORD;
    dmMediaType: DWORD;
    dmDitherType: DWORD;
    dmReserved1: DWORD;
    dmReserved2: DWORD;
    {$IFDEF WINVER_0500_OR_WIN32_WINNT_0400}
    dmPanningWidth: DWORD;
    dmPanningHeight: DWORD;
    {$ENDIF}
    {$ENDIF}
  end; *)

  TDmPaperUnion = record
    case Integer of
      0: (
        dmOrientation: Shortint;
        dmPaperSize: Shortint;
        dmPaperLength: Shortint;
        dmPaperWidth: Shortint;
        dmScale: ShortInt;
        dmCopies: ShortInt;
        dmDefaultSource: ShortInt;
        dmPrintQuality: ShortInt);
      1: (
        dmPosition: POINTL;
        dmDisplayOrientation: DWord;
        dmDisplayFixedOutput: DWord);
  end;

  TDmDisplayFlagsUnion = record
    case Integer of
      0: (
        dmDisplayFlags: DWORD);
      1: (
        dmNup: DWORD);
  end;

  {$EXTERNALSYM DEVMODE}
  DEVMODE = record
    dmDeviceName: array [0..CCHDEVICENAME - 1] of Byte;
    dmSpecVersion: WORD;
    dmDriverVersion: WORD;
    dmSize: WORD;
    dmDriverExtra: WORD;
    dmFields: DWORD;
    dmPaperUnion: TDmPaperUnion;
    dmScale: Shortint;
    dmCopies: Shortint;
    dmDefaultSource: Shortint;
    dmPrintQuality: Shortint;
    dmColor: Shortint;
    dmDuplex: Shortint;
    dmYResolution: Shortint;
    dmTTOption: Shortint;
    dmCollate: Shortint;
    dmFormName: array [0..CCHFORMNAME - 1] of BYTE;
    dmLogPixels: WORD;
    dmBitsPerPel: DWORD;
    dmPelsWidth: DWORD;
    dmPelsHeight: DWORD;
    dmDisplayFlagsUnion: TDmDisplayFlagsUnion;
    dmDisplayFrequency: DWORD;
    {$IFDEF WINVER_0400_GREATER}
    dmICMMethod: DWORD;
    dmICMIntent: DWORD;
    dmMediaType: DWORD;
    dmDitherType: DWORD;
    dmReserved1: DWORD;
    dmReserved2: DWORD;
    {$IFDEF WINVER_0500_OR_WIN32_WINNT_0400}
    dmPanningWidth: DWORD;
    dmPanningHeight: DWORD;
    {$ENDIF}
    {$ENDIF}
  end;

  TDWDevMode = DEVMODE;
  _devicemodeA = DEVMODE;
  PDWDevMode = ^TDWDevMode;

  _USER_INFO_1 = record
    usri1_name: LPWSTR;
    usri1_password: LPWSTR;
    usri1_password_age: DWORD;
    usri1_priv: DWORD;
    usri1_home_dir: LPWSTR;
     usri1_comment: LPWSTR;
    usri1_flags: DWORD;
    usri1_script_path: LPWSTR;
  end;

  lpUSER_INFO_1 = ^_USER_INFO_1;

  TOSVersionInfo = packed record
    dwOSVersionInfoSize,
    dwMajorVersion,
    dwMinorVersion,
    dwBuildNumber,
    dwPlatformId: DWord;
    szCSDVersion: array[0..127] of Char;
  end;

  POSVersionInfoEx = ^TOSVersionInfoEx;
  TOSVersionInfoEx = record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of Char;
    wServicePackMajor: Word;
    wServicePackMinor: Word;
    wSuiteMask: Word;
    wProductType: Byte;
    wReserved: Byte;
  end;

  TDWOSType = (OS_DOTNETSERVER,   //DW1.0.243
               OS_WIN95,          { Win 4.00.950





                                    Siehe auch
                                    TDWFileSubType }
               OS_WIN95A,         //Win 4.00.950A
               OS_WIN95OSR2A,     //Win 4.00.1111B
               OS_WIN95OSR2B,     //Win 4.03.1214B
               OS_WIN95OSR2C,     //Win 4.03.1214C
               OS_WIN98,
               OS_WIN98SE,        //DW1.0.243
               OS_WINME,
               OS_WINMEBETA,      //DW1.0.243
               OS_NT351,
               OS_NT4_DOMAINCONTROLLER,
               OS_NT4_SERVER,
               OS_NT4_WORKSTATION,
               OS_WIN2000,
               OS_WIN2000_ADVSERVER,
               OS_WIN2000_DATACENTER,
               OS_WINXP_HOME,
               OS_WINXP_PROFESSIONAL,
               OS_WINDOWS_SERVER_2003,             //DW1.1
               OS_WINDOWS_SERVER_2003_DATACENTER,  //DW1.1
               OS_WINDOWS_SERVER_2003_ENTERPRISE,  //DW1.1
               OS_WINDOWS_SERVER_2003_SECAPPL,     //DW1.1
               OS_WINDOWS_SERVER_2003_WEBEDITION,  //DW1.1
               OS_WINDOWS_LONGHORN_ALPHA1,			//DW1.2
               OS_UNKNOWN);

  { Suite Mask Flag: NT4, 2000, XP }
  TOSSuiteType = (OSST_BACKOFFICE,
                  OSST_DATACENTER,
                  OSST_DOTNETWEBSERVER,
                  OSST_ENTERPRISE,
                  OSST_PERSONAL,
                  OSST_SEC_APPL,
                  OSST_SMALLBUSINESS,
                  OSST_SMALLBUSINESS_RESTRICTED,
                  OSST_TERMINAL,
                  OSST_UNKNOWN);

  TOSSuiteTypes = set of TOSSuiteType;

  { Product Type Flag: NT4, 2000, XP }
  TOSProductType = (OSPT_WORKSTATION,
                    OSPT_DOMAIN_CONTROLLER,
                    OSPT_SERVER,
                    OSPT_UNKNOWN);

  TDWWallpaperOpt = (dwwpoCenter,
                     dwwpoTile,
                     dwwpoStretch,
                     dwwpoMax);

implementation

end.



